import { SourceLocation, Position, ElementNode, DirectiveNode, TemplateChildNode, RootNode, Property, JSChildNode, SlotOutletNode, TemplateNode, RenderSlotCall, ExpressionNode, IfBranchNode, TextNode, InterpolationNode, VNodeCall, SimpleExpressionNode } from './ast';
import { TransformContext } from './transform';
export declare const isStaticExp: (p: JSChildNode) => p is SimpleExpressionNode;
export declare const isBuiltInType: (tag: string, expected: string) => boolean;
export declare function isCoreComponent(tag: string): symbol | void;
export declare const isSimpleIdentifier: (name: string) => boolean;
export declare const isMemberExpression: (path: string) => boolean;
export declare function getInnerRange(loc: SourceLocation, offset: number, length?: number): SourceLocation;
export declare function advancePositionWithClone(pos: Position, source: string, numberOfCharacters?: number): Position;
export declare function advancePositionWithMutation(pos: Position, source: string, numberOfCharacters?: number): Position;
export declare function assert(condition: boolean, msg?: string): void;
export declare function findDir(node: ElementNode, name: string | RegExp, allowEmpty?: boolean): DirectiveNode | undefined;
export declare function findProp(node: ElementNode, name: string, dynamicOnly?: boolean, allowEmpty?: boolean): ElementNode['props'][0] | undefined;
export declare function isBindKey(arg: DirectiveNode['arg'], name: string): boolean;
export declare function hasDynamicKeyVBind(node: ElementNode): boolean;
export declare function isText(node: TemplateChildNode): node is TextNode | InterpolationNode;
export declare function isVSlot(p: ElementNode['props'][0]): p is DirectiveNode;
export declare function isTemplateNode(node: RootNode | TemplateChildNode): node is TemplateNode;
export declare function isSlotOutlet(node: RootNode | TemplateChildNode): node is SlotOutletNode;
export declare function injectProp(node: VNodeCall | RenderSlotCall, prop: Property, context: TransformContext): void;
export declare function toValidAssetId(name: string, type: 'component' | 'directive'): string;
export declare function hasScopeRef(node: TemplateChildNode | IfBranchNode | ExpressionNode | undefined, ids: TransformContext['identifiers']): boolean;
//# sourceMappingURL=utils.d.ts.map