import { LazyResult, Result } from 'postcss';
import { PreprocessLang } from './stylePreprocessors';
import { RawSourceMap } from 'source-map';
export interface SFCStyleCompileOptions {
    source: string;
    filename: string;
    id: string;
    map?: RawSourceMap;
    scoped?: boolean;
    vars?: boolean;
    trim?: boolean;
    preprocessLang?: PreprocessLang;
    preprocessOptions?: any;
    preprocessCustomRequire?: (id: string) => any;
    postcssOptions?: any;
    postcssPlugins?: any[];
}
export interface SFCAsyncStyleCompileOptions extends SFCStyleCompileOptions {
    isAsync?: boolean;
    modules?: boolean;
    modulesOptions?: {
        scopeBehaviour?: 'global' | 'local';
        globalModulePaths?: string[];
        generateScopedName?: string | ((name: string, filename: string, css: string) => string);
        hashPrefix?: string;
        localsConvention?: 'camelCase' | 'camelCaseOnly' | 'dashes' | 'dashesOnly';
    };
}
export interface SFCStyleCompileResults {
    code: string;
    map: RawSourceMap | undefined;
    rawResult: LazyResult | Result | undefined;
    errors: Error[];
    modules?: Record<string, string>;
    dependencies: Set<string>;
}
export declare function compileStyle(options: SFCStyleCompileOptions): SFCStyleCompileResults;
export declare function compileStyleAsync(options: SFCAsyncStyleCompileOptions): Promise<SFCStyleCompileResults>;
export declare function doCompileStyle(options: SFCAsyncStyleCompileOptions): SFCStyleCompileResults | Promise<SFCStyleCompileResults>;
//# sourceMappingURL=compileStyle.d.ts.map