import { RootNode, BlockStatement, TemplateLiteral, TemplateChildNode, CompilerOptions, IfStatement, CallExpression } from '@atom-vue/compiler-dom';
export declare function ssrCodegenTransform(ast: RootNode, options: CompilerOptions): void;
export declare type SSRTransformContext = ReturnType<typeof createSSRTransformContext>;
declare function createSSRTransformContext(root: RootNode, options: CompilerOptions, helpers?: Set<symbol>, withSlotScopeId?: boolean): {
    root: RootNode;
    options: CompilerOptions;
    body: (import("../../compiler-dom/src").SimpleExpressionNode | import("../../compiler-dom/src").CompoundExpressionNode | import("../../compiler-dom/src").VNodeCall | CallExpression | import("../../compiler-dom/src").ObjectExpression | import("../../compiler-dom/src").ArrayExpression | import("../../compiler-dom/src").FunctionExpression | import("../../compiler-dom/src").ConditionalExpression | import("../../compiler-dom/src").CacheExpression | import("../../compiler-dom/src").AssignmentExpression | import("../../compiler-dom/src").SequenceExpression | IfStatement)[];
    helpers: Set<symbol>;
    withSlotScopeId: boolean;
    onError: ((error: import("../../compiler-dom/src").CompilerError) => void) & ((error: import("../../compiler-dom/src").CompilerError) => void);
    helper<T extends symbol>(name: T): T;
    pushStringPart(part: TemplateLiteral['elements'][0]): void;
    pushStatement(statement: IfStatement | CallExpression): void;
};
export declare function processChildren(children: TemplateChildNode[], context: SSRTransformContext, asFragment?: boolean): undefined;
export declare function processChildrenAsStatement(children: TemplateChildNode[], parentContext: SSRTransformContext, asFragment?: boolean, withSlotScopeId?: boolean): BlockStatement;
export {};
//# sourceMappingURL=ssrCodegenTransform.d.ts.map