import { ReactiveEffect } from './effect';
import { Ref } from './ref';
export interface ComputedRef<T = any> extends WritableComputedRef<T> {
    readonly value: T;
}
export interface WritableComputedRef<T> extends Ref<T> {
    readonly effect: ReactiveEffect<T>;
}
export declare type ComputedGetter<T> = (ctx?: any) => T;
export declare type ComputedSetter<T> = (v: T) => void;
export interface WritableComputedOptions<T> {
    get: ComputedGetter<T>;
    set: ComputedSetter<T>;
}
export declare function computed<T>(getter: ComputedGetter<T>): ComputedRef<T>;
export declare function computed<T>(options: WritableComputedOptions<T>): WritableComputedRef<T>;
//# sourceMappingURL=computed.d.ts.map