import { ComponentInternalInstance, ConcreteComponent } from './component';
import { UnionToIntersection } from './helpers/typeUtils';
import { AppContext } from './apiCreateApp';
export declare type ObjectEmitsOptions = Record<string, ((...args: any[]) => any) | null>;
export declare type EmitsOptions = ObjectEmitsOptions | string[];
export declare type EmitFn<Options = ObjectEmitsOptions, Event extends keyof Options = keyof Options> = Options extends any[] ? (event: Options[0], ...args: any[]) => void : {} extends Options ? (event: string, ...args: any[]) => void : UnionToIntersection<{
    [key in Event]: Options[key] extends ((...args: infer Args) => any) ? (event: key, ...args: Args) => void : (event: key, ...args: any[]) => void;
}[Event]>;
export declare function emit(instance: ComponentInternalInstance, event: string, ...args: any[]): void;
export declare function normalizeEmitsOptions(comp: ConcreteComponent, appContext: AppContext, asMixin?: boolean): ObjectEmitsOptions | null;
export declare function isEmitListener(options: ObjectEmitsOptions | null, key: string): boolean;
//# sourceMappingURL=componentEmits.d.ts.map