import { ComponentInternalInstance } from './component';
import { VNode, VNodeNormalizedChildren } from './vnode';
import { SlotFlags } from '@atom-vue/shared';
export declare type Slot = (...args: any[]) => VNode[];
export declare type InternalSlots = {
    [name: string]: Slot | undefined;
};
export declare type Slots = Readonly<InternalSlots>;
export declare type RawSlots = {
    [name: string]: unknown;
    $stable?: boolean;
    /**
     * for tracking slot owner instance. This is attached during
     * normalizeChildren when the component vnode is created.
     * @internal
     */
    _ctx?: ComponentInternalInstance | null;
    /**
     * indicates compiler generated slots
     * we use a reserved property instead of a vnode patchFlag because the slots
     * object may be directly passed down to a child component in a manual
     * render function, and the optimization hint need to be on the slot object
     * itself to be preserved.
     * @internal
     */
    _?: SlotFlags;
};
export declare const initSlots: (instance: ComponentInternalInstance, children: VNodeNormalizedChildren) => void;
export declare const updateSlots: (instance: ComponentInternalInstance, children: VNodeNormalizedChildren) => void;
//# sourceMappingURL=componentSlots.d.ts.map