import { ComponentInternalInstance } from '../component';
import { VNode, VNodeProps } from '../vnode';
import { RendererInternals, RendererElement, RendererNode } from '../renderer';
import { ComponentRenderContext } from '../componentPublicInstance';
declare type MatchPattern = string | RegExp | string[] | RegExp[];
export interface KeepAliveProps {
    include?: MatchPattern;
    exclude?: MatchPattern;
    max?: number | string;
}
export interface KeepAliveContext extends ComponentRenderContext {
    renderer: RendererInternals;
    activate: (vnode: VNode, container: RendererElement, anchor: RendererNode | null, isSVG: boolean, optimized: boolean) => void;
    deactivate: (vnode: VNode) => void;
}
export declare const isKeepAlive: (vnode: VNode) => boolean;
export declare const KeepAlive: {
    new (): {
        $props: VNodeProps & KeepAliveProps;
    };
    __isKeepAlive: true;
};
export declare function onActivated(hook: Function, target?: ComponentInternalInstance | null): void;
export declare function onDeactivated(hook: Function, target?: ComponentInternalInstance | null): void;
export {};
//# sourceMappingURL=KeepAlive.d.ts.map