import { App } from './apiCreateApp';
import { ComponentInternalInstance } from './component';
interface AppRecord {
    id: number;
    app: App;
    version: string;
    types: Record<string, string | Symbol>;
}
interface DevtoolsHook {
    emit: (event: string, ...payload: any[]) => void;
    on: (event: string, handler: Function) => void;
    once: (event: string, handler: Function) => void;
    off: (event: string, handler: Function) => void;
    appRecords: AppRecord[];
}
export declare let devtools: DevtoolsHook;
export declare function setDevtoolsHook(hook: DevtoolsHook): void;
export declare function devtoolsInitApp(app: App, version: string): void;
export declare function devtoolsUnmountApp(app: App): void;
export declare const devtoolsComponentAdded: (component: ComponentInternalInstance) => void;
export declare const devtoolsComponentUpdated: (component: ComponentInternalInstance) => void;
export declare const devtoolsComponentRemoved: (component: ComponentInternalInstance) => void;
export declare function devtoolsComponentEmit(component: ComponentInternalInstance, event: string, params: any[]): void;
export {};
//# sourceMappingURL=devtools.d.ts.map