import { RootRenderFunction, CreateAppFunction, RootHydrateFunction } from '@atom-vue/runtime-core';
import { RendererOptions, RendererNode, RendererElement } from '@atom-vue/runtime-core';
import { Component } from 'packages/runtime-core/src/component';
declare module '@atom-vue/reactivity' {
    interface RefUnwrapBailTypes {
        runtimeDOMBailTypes: Node | Window;
    }
}
export declare function setElementTags(elementTags: string): void;
export declare function onRootMounted(callback: Function): void;
export declare function onRootPreMounted(callback: Function): void;
export declare function setRenderOptions<HostNode = RendererNode, HostElement = RendererElement>(options: RendererOptions<HostNode, HostElement>): void;
export declare function setComponents(components: Record<string, Component>): void;
export declare const render: RootRenderFunction<Element>;
export declare const hydrate: RootHydrateFunction;
export declare const createApp: CreateAppFunction<Element>;
export declare const createSSRApp: CreateAppFunction<Element>;
export { useCssModule } from './helpers/useCssModule';
export { useCssVars } from './helpers/useCssVars';
export { Transition, TransitionProps } from './components/Transition';
export { TransitionGroup, TransitionGroupProps } from './components/TransitionGroup';
export { vModelText, vModelCheckbox, vModelRadio, vModelSelect, vModelDynamic } from './directives/vModel';
export { withModifiers, withKeys } from './directives/vOn';
export { vShow } from './directives/vShow';
export * from '@atom-vue/runtime-core';
export { setExternGlobals } from '@atom-vue/shared';
//# sourceMappingURL=index.d.ts.map