import { ComponentInternalInstance, VNode, VNodeArrayChildren } from '@atom-vue/vue';
export declare type SSRBuffer = SSRBufferItem[] & {
    hasAsync?: boolean;
};
export declare type SSRBufferItem = string | SSRBuffer | Promise<SSRBuffer>;
export declare type PushFn = (item: SSRBufferItem) => void;
export declare type Props = Record<string, unknown>;
export declare type SSRContext = {
    [key: string]: any;
    teleports?: Record<string, string>;
    __teleportBuffers?: Record<string, SSRBuffer>;
};
export declare function createBuffer(): {
    getBuffer(): SSRBuffer;
    push(item: SSRBufferItem): void;
};
export declare function renderComponentVNode(vnode: VNode, parentComponent?: ComponentInternalInstance | null): SSRBuffer | Promise<SSRBuffer>;
export declare function renderVNode(push: PushFn, vnode: VNode, parentComponent: ComponentInternalInstance): void;
export declare function renderVNodeChildren(push: PushFn, children: VNodeArrayChildren, parentComponent: ComponentInternalInstance): void;
//# sourceMappingURL=render.d.ts.map